<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Targeting</title>

    <link rel="stylesheet" href="/en/latestcss/core.css">
    <link rel="stylesheet" href="/en/latestcss/getstarted.css">
    <link rel="shortcut icon" href="/en/latestcss/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latestcss/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest">Documentation</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latestcontents.html">Reference Guide</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latesttopics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>SaltStack Fundamentals</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="6">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/fundamentals/index.html">Demo Environment</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/fundamentals/install.html">Install SaltStack</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/fundamentals/remotex.html">Execute Commands</a>
                </li>
                
                
                
                <li class="progtrckr-done">Targeting</li>
                
                
                
                
                
                
                
                
                
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/fundamentals/states.html">Create a Salt State</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/fundamentals/top.html">Apply and Target States</a>
                </li>
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Targeting</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Define a target to select one or more systems.</li>
                    
                    <li class="progtrckr-done">Use system data to define a target.</li>
                    
                    <li class="progtrckr-done">Use custom, user-defined data to define a target.</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 10 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <p>Targeting is how you select Salt minions when running commands, applying configurations, and when doing almost anything else in SaltStack that involves a Salt minion.</p>
<p>The simplest way to target is using the Salt minion ID. This value can be set to anything you want in the minion config file, and can be specified using the <code>-i</code> option in the bootstrap script.</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> <span class="st">&#39;minion1&#39;</span> disk.usage</code></pre>
<h4 id="globbing">Globbing</h4>
<p><a id="globbing-modal" href="#">Globbing</a> on the Salt minion ID is supported by simply including a wildcard in the target:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> <span class="st">&#39;minion*&#39;</span> disk.usage</code></pre>
<div class="section sidebar">
<h4 id="grains">Grains</h4>
<p>Grains are static information SaltStack collects about the underlying managed system. SaltStack collects grains for the operating system, domain name, IP address, kernel, OS type, memory, and many other system properties.</p>
<p>You can add your own grains to a Salt minion by placing them in the <code>/etc/salt/grains</code> file on the Salt master, or in the Salt minion configuration file under the <code>grains</code> section. For example, many users add a custom grain called <code>role</code> to each Salt minion to describe the function of the system.</p>
<p>You can use the <code>grains.ls</code> command to list all of the grains on a Salt minion:</p>
<p><img class="imgcenter" width="100%" src="/en/getstarted/images/vagrant-grains.png"></p>
<p>Note that grain names are lowercase.</p>
</div>
<h2 id="so-many-ways-to-target">So Many Ways to Target</h2>
<p>In an ideal world, each system in your environment has a structured name that tells you everything you need to know about the hardware, OS, and system role. While we wait for that world, SaltStack provides a powerful targeting system to help you find and filter systems based on static and custom data.</p>
<p>Targets can be based on Salt minion system information using the Grains system:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> -G <span class="st">&#39;os:Ubuntu&#39;</span> test.ping</code></pre>
<p>Targets can be filtered by regular expression:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> -E <span class="st">&#39;minion[0-9]&#39;</span> test.ping</code></pre>
<p>Targets can be explicitly specified in a list:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> -L <span class="st">&#39;minion1,minion2&#39;</span> test.ping</code></pre>
<p>Or Multiple target types can be combined in one command:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> -C <span class="st">&#39;G@os:Ubuntu and minion* or S@192.168.50.*&#39;</span> test.ping</code></pre>
<p>Don’t worry too much about these targeting methods just yet. Just be confident that the targeting mechanism has enough flexibility to find the systems that you want to manage.</p>
<h4 id="got-it-whats-next">Got it, What’s Next?</h4>
<p>Hopefully you’ve got a good understanding of how execution modules are used from the command line, and how to filter Salt minions using targets. The next step is to define re-usable configuration templates, called states, so we can make more awesomeness happen at once.</p>


            <br>
            
            <a href="/en/getstarted/fundamentals/remotex.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/getstarted/fundamentals/states.html">
                <button type="button" class="btn btn-primary btn-right">
                    Next <span class="glyphicon glyphicon-chevron-right"></span></button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
    <p>© 2020 SaltStack | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latestjs/core-min.js"></script>


<!--Modals-->
<script type="text/javascript" src="../js/bootbox-min.js"></script>
<script type="text/javascript">
   $( document ).ready(function() {
       
       $("#globbing-modal").on("click", function(e) {
           e.preventDefault();
           bootbox.dialog({
               title: "Globbing?",
               
               message: '<p>Globbing lets you match one or more Salt minion IDs using a wildcard character. Asterisk (<strong>*</strong>) matches one or more characters, and question mark (<strong>?</strong>) matches a single character. </p> <p>This is useful if your Salt minion IDs are configured according to function, for example, web1, web2, db1, db2, and so on.</p>',
               buttons: {
                   success: {
                       label: "Easy!"
                   }
               }
           });
       });
       
   });
</script>


<!--analytics-->
<script type="text/javascript" language="javascript">llactid=23943</script>
<script type="text/javascript" language="javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>